//
//  View.m
//  Motion
//
//  Created by NYU User on 10/13/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "View.h"


@implementation View


- (id) initWithFrame: (CGRect) frame {
	if ((self = [super initWithFrame: frame])) {
		// Initialization code
		self.backgroundColor = [UIColor whiteColor];
		message = @"";
	}
	return self;
}

- (void) erase {
	self.backgroundColor = [UIColor whiteColor];
	message = @"";
	[self setNeedsDisplay];
}

// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void) drawRect: (CGRect) rect {
	// Drawing code
	UIFont *f = [UIFont systemFontOfSize: 72];
	[message drawAtPoint: CGPointZero withFont: f];
}

- (void) dealloc {
    [super dealloc];
}

#pragma mark -
#pragma mark override methods of class UIResponder

- (BOOL) canBecomeFirstResponder {
	return YES;
}

- (void) motionBegan: (UIEventSubtype) motion
	withEvent: (UIEvent *) event {
	
	//Always true, since for the time being a shake
	//is the only kind of motion it recognizes.
	if (motion == UIEventSubtypeMotionShake
		&& event.type == UIEventTypeMotion
		&& event.subtype == UIEventSubtypeMotionShake) {
		
		message = @"Shake!";
		[self setNeedsDisplay];	//trigger a call to drawRect:

		[self performSelector: @selector(erase)
			withObject: nil
			afterDelay: .5];
	}
}

/*
- (void) motionEnded: (UIEventSubtype) motion
	withEvent: (UIEvent *) event {
}
 */

- (void) motionCancelled: (UIEventSubtype) motion
	withEvent: (UIEvent *) event {
	message = @"";
	[self setNeedsDisplay];
}

@end
